import './Main.sass'
import { Logo, Link, Page, Row, Padding, ModalButton, Box, Button, Modal, Column, Clickable } from '../../components/'
import { FiLogOut } from 'solid-icons/fi'
import { Tabs } from '@kobalte/core/tabs'
import { ofetch } from 'ofetch'
import { onMount, createSignal } from 'solid-js'
import dayjs from 'dayjs'
import { checkConnection, createPdf } from '../../utils/functions'
import { FaSolidThumbsUp } from 'solid-icons/fa'
import { _employeeName } from '../../stores/employee'
import { useNavigate } from '@solidjs/router'
import { _applicationNo, _date, _optn, _name, _location, _type, _assessor, _feeList, _codeList, _amountList, _signatureAssessor, _signatureApprover, _assessorid, _approvedDate, _assessedDate } from '../../stores/pdfinfo'
import { VsRefresh } from 'solid-icons/vs'

const API = import.meta.env.VITE_BACKEND
const PESO = import.meta.env.VITE_PESO
const ID = import.meta.env.VITE_HEADID
// const NAME = import.meta.env.VITE_HEAD
const PUBLICIP = import.meta.env.VITE_PUBLICIP

export default () => {
  const navigate = useNavigate()

  const [totalOp, setTotalOp] = createSignal(0)
  const [assessor, setAssessor] = createSignal('')
  const [dateOp, setDateOp] = createSignal('')
  const [location, setLocation] = createSignal('')
  const [type, setType] = createSignal('')
  const [applicationId, setApplicationId] = createSignal(0)
  // const [assessorId, setAssessorId] = createSignal(0)

  // const [gflgu, setGflgu] = createSignal<number[]>([])
  // const [gfdpwh, setGfdpwh] = createSignal<number[]>([])
  // const [tfbo, setTfbo] = createSignal<number[]>([])

  // const [descriptionList, setDescriptionList] = createSignal<string[]>([])
  // const [amountList, setAmountList] = createSignal<string[]>([])
  // const [dateOpList, setDateOpList] = createSignal<string[]>([])

  const [applicationListElectrical, setApplicationListElectrical] = createSignal<string[]>([])
  const [nameListElectrical, setNameListElectrical] = createSignal<string[]>([])
  const [applicationListOccupancy, setApplicationListOccupancy] = createSignal<string[]>([])
  const [nameListOccupancy, setNameListOccupancy] = createSignal<string[]>([])

  const [errorMessage, setErrorMessage] = createSignal('')
  const [connected, setConnected] = createSignal(true)
  const [approved, setApproved] = createSignal(false)
  const [approvedApplication, setApprovedApplication] = createSignal('')

  const [employeeId, setEmployeeId] = createSignal(0)
  const [employeeName, setEmployeeName] = createSignal('')

  const getListForApproval = async () => {
    try {
      const responseE = await ofetch(API + 'get-listopapproval-electrical', { parseResponse: JSON.parse })
      setApplicationListElectrical(responseE.result)
      setNameListElectrical(responseE.result2)

      const responseO = await ofetch(API + 'get-listopapproval-occupancy', { parseResponse: JSON.parse })
      setApplicationListOccupancy(responseO.result)
      setNameListOccupancy(responseO.result2)
    } catch (error) {
      console.error(error)
    }
  }

  const getListForApprovalElectrical = async () => {
    try {
      const responseE = await ofetch(API + 'get-listopapproval-electrical', { parseResponse: JSON.parse })
      setApplicationListElectrical(responseE.result)
      setNameListElectrical(responseE.result2)
    } catch (error) {
      console.error(error)
    }
  }

  const getListForApprovalOccupancy = async () => {
    try {
      const responseO = await ofetch(API + 'get-listopapproval-occupancy', { parseResponse: JSON.parse })
      setApplicationListOccupancy(responseO.result)
      setNameListOccupancy(responseO.result2)
    } catch (error) {
      console.error(error)
    }
  }

  const load = async (division: string) => {
    setConnected(await checkConnection())
    if (connected() === false) {
      setErrorMessage('Could not gather list of applicaitons')
      return
    }

    if (division === 'electrical') {
      await getListForApprovalElectrical()
    }
    if (division === 'occupancy') {
      await getListForApprovalOccupancy()
    } else {
      await getListForApproval()
    }
  }

  const getopdetails = async (division: string, applicationNo: string) => {
    if (division === 'electrical') {
      const op = await ofetch(API + 'get-opdetails-electrical/' + applicationNo, { parseResponse: JSON.parse })
      setAssessor(op.result7[0])
      setLocation(op.result5[0])
      setType(op.result6[0])
      setDateOp(dayjs(op.result10[0]).format('MMMM DD, YYYY'))
      setApplicationId(op.result11[0])
      setTotalOp(calculateTotal(op.result9))
    } else if (division === 'occupancy') {
      const op = await ofetch(API + 'get-opdetails-occupancy/' + applicationNo, { parseResponse: JSON.parse })
      setAssessor(op.result7[0])
      setLocation(op.result5[0])
      setType(op.result6[0])
      setDateOp(dayjs(op.result10[0]).format('MMMM DD, YYYY'))
      setApplicationId(op.result11[0])
      setTotalOp(calculateTotal(op.result9))
    }
  }

  const calculateTotal = (list: number[]) => {
    const total = list.map((item) => parseFloat(item.toString())).reduce((acc, curr) => acc + curr, 0)
    return total
  }

  const approveHandler = async (application: string) => {
    let signed: boolean = false
    let forprinting: boolean = false
    let updateOrderofpayment: boolean = false

    setConnected(await checkConnection())
    if (connected() === false) {
      setErrorMessage('No Connection on Server')
      return
    }

    signed = await setNewStatus('ELECTRICAL ORDER OF PAYMENT APPROVED AND SIGNED', '170', 'ELECOPAPPROVEDSIGNED', 1)
    const approvedid = await getIdByApplication(application)
    updateDocflow(approvedid, 'FOR ELECTRICAL ORDER OF PAYMENT APPROVAL')
    if (!signed) return

    forprinting = await setNewStatus('FOR ELECTRICAL ORDER OF PAYMENT PRINTING', '95', 'ELECOPPRINT', 0)
    if (!forprinting) return

    updateOrderofpayment = await updateOp()

    if (updateOrderofpayment) {
      postTransaction()
      postPops(application)
      setApprovedApplication(application)
      setApproved(true)
    }
  }

  const setNewStatus = async (status: string, tag: string, tagword: string, approved: number) => {
    const today = new Date()
    const formattedDate = dayjs(today).format('YYYY-MM-DD HH:mm:ss')
    const statusid = parseInt(applicationId().toString())

    try {
      await ofetch(API + 'post-newstatus-electrical', {
        method: 'POST',
        body: { data: statusid, data2: formattedDate, data3: status, data4: tag, data5: tagword, data6: parseInt(approved.toString()), data7: parseInt(ID) },
      })
      return true
    } catch {
      return false
    }
  }

  const updateOp = async () => {
    try {
      await ofetch(API + 'update-opapproved-electrical', {
        method: 'POST',
        body: { data: parseInt(applicationId().toString()) },
      })
      return true
    } catch {
      return false
    }
  }

  // const getPrintDetails = async (id: number) => {
  //   const response = await ofetch(API + 'get-printdetails-electrical/' + id)
  //   const applicationno = response.result
  //   const date = response.result2
  //   const location = response.result3
  //   const name = response.result8
  //   const type = `${response.result4} - ${response.result5}`
  //   const assessor = response.result7

  //   _optn.set('M' + applicationno.split('-')[0] + applicationno.split('-')[1])
  //   _applicationNo.set(applicationno)
  //   _date.set(dayjs(date).format('MMMM DD, YYYY'))
  //   _name.set(name)
  //   _location.set(location)
  //   _type.set(type)
  //   _assessor.set(assessor)
  //   _assessorid.set(employeeId())
  // }

  const postPops = async (application: string) => {
    const applicationId = await ofetch(API + 'get-idbyapplication-electrical/' + application, { parseResponse: JSON.parse })
    const response = await ofetch(API + 'get-popsdetails-electrical/' + applicationId.result, { parseResponse: JSON.parse })
    // const applicationNo = response.result[0]
    const customerid = response.result2[0]
    const customerName = response.result3[0]
    const location = response.result4[0]
    const amountList = response.result5
    const lguList = response.result6
    const dpwhList = response.result7
    const boList = response.result8
    const codeList = response.result9

    const today = new Date()
    const formattedDate = dayjs(today).format('YYYY-MM-DD')
    const formattedDatewithTime = dayjs(today).format('YYYY-MM-DD HH:mm:ss')

    for (let i = 0; i < response.result.length; i++) {
      await ofetch(API + 'post-pops', {
        method: 'POST',
        body: { data: application, data2: formattedDate, data3: customerid, data4: customerName, data5: location, data6: codeList[i], data7: amountList[i], data8: assessor(), data9: formattedDatewithTime, data10: lguList[i], data11: dpwhList[i], data12: boList[i], data13: PUBLICIP },
      })
    }
  }

  // const calculateAmounts = () => {
  //   const amounts: string[] = amountList()
  //   let gflguList: number[] = []
  //   let gfdpwhList: number[] = []
  //   let tfboList: number[] = []

  //   for (let i = 0; i < amounts.length; i++) {
  //     const gflgu = parseFloat(amounts[i]) * 0.8
  //     const gfdpwh = parseFloat(amounts[i]) * 0.05
  //     const tfbo = parseFloat(amounts[i]) * 0.15

  //     const roundedGflgu = parseFloat(gflgu.toFixed(2))
  //     const roundedGfdpwh = parseFloat(gfdpwh.toFixed(2))
  //     const roundedTfbo = parseFloat(tfbo.toFixed(2))

  //     gflguList.push(roundedGflgu)
  //     gfdpwhList.push(roundedGfdpwh)
  //     tfboList.push(roundedTfbo)
  //   }

  //   setGflgu(gflguList)
  //   setGfdpwh(gfdpwhList)
  //   setTfbo(tfboList)
  // }

  const closeNotification = async () => {
    setApproved(false)
    await load('all')
  }

  const removeEmployee = () => {
    sessionStorage.removeItem('id')
    sessionStorage.removeItem('name')
  }

  const checkLogged = async () => {
    const idStore = sessionStorage.getItem('id')
    const nameStore = sessionStorage.getItem('name')
    setEmployeeId(parseInt(idStore!))
    setEmployeeName(nameStore!)

    if (employeeId() === 0 || employeeId().toString() === 'NaN') {
      removeEmployee()
      navigate('/', { replace: true })
      return false
    }
    return true
  }

  const geteSignId = async () => {
    try {
      const response = await ofetch(API + 'get-esignid/' + ID, { parseResponse: JSON.parse })
      const result = response.result
      return result
    } catch {
      return 0
    }
  }

  const postTransaction = async () => {
    const id = await geteSignId()
    const today = new Date()
    const formatedDate = dayjs(today).format('YYYY-MM-DD HH:mm:ss')
    await ofetch(API + 'post-esigntransaction', {
      method: 'POST',
      body: { data: parseInt(id), data2: approvedApplication(), data3: formatedDate },
    })
  }

  const updateDocflow = async (electricalid: number, status: string) => {
    await ofetch(API + 'update-docflow-electrical', {
      method: 'POST',
      body: { data: parseInt(electricalid.toString()), data2: status },
    })
  }

  const getIdByApplication = async (applicationNo: string) => {
    try {
      const response = await ofetch(API + 'get-idbyapplication-electrical/' + applicationNo, { parseResponse: JSON.parse })
      const result = response.result
      return parseInt(result)
    } catch {
      return 0
    }
  }

  const refresh = async (division: string) => {
    if (division === 'electrical') {
      await load('electrical')
    } else if (division === 'occupancy') {
      await load('occupancy')
    } else {
      await load('all')
    }
  }

  const logout = async () => {
    removeEmployee()
    navigate('/')
  }

  onMount(async () => {
    const logged = await checkLogged()

    if (logged) {
      await load('all')
    }
  })

  return (
    <>
      <Page alignment="column">
        <Padding left={4.75} right={4.75} top={0} bottom={0}>
          <Row content="split">
            <Link to="/">
              <Row content="left" gap={2}>
                <Logo size={200} />
                <h1>OCBO e-Sign</h1>
              </Row>
            </Link>

            <Row content="left" gap={1}>
              <Box curved thickness={0} padding="1.25rem 2.25rem" background="#0f131d56">
                <span class="name">{employeeName()}</span>
              </Box>
              <Clickable onClick={logout}>
                <Row gap={0.5}>
                  <FiLogOut size={25} />
                  <span>Logout</span>
                </Row>
              </Clickable>
            </Row>
          </Row>
          <Row content="center">
            <Tabs aria-label="Main navigation" class="tabs">
              <Row>
                <Tabs.List class="tabs__list">
                  <Tabs.Trigger class="tabs__trigger" value="building">
                    Building
                  </Tabs.Trigger>
                  <Tabs.Trigger class="tabs__trigger" value="occupancy">
                    Occupancy
                  </Tabs.Trigger>
                  <Tabs.Trigger class="tabs__trigger" value="electrical">
                    Electrical
                  </Tabs.Trigger>
                  <Tabs.Indicator class="tabs__indicator" />
                </Tabs.List>
              </Row>

              <Tabs.Content class="tabs__content" value="building">
                <Row>
                  {/* <h2>List of Ready to Approve and Sign Building Order of Payments</h2> */}
                  <Box curved thickness={0} background="#602a2abf" padding="1rem 2rem">
                    <h2>Under Development</h2>
                  </Box>
                </Row>

                <Row>
                  <table class="table">
                    <thead>
                      {/* <tr>
                        <th>Application Number</th>
                        <th>Name</th>
                        <th style="text-align: center">Show Details</th>
                      </tr> */}
                    </thead>
                    <tbody></tbody>
                  </table>
                </Row>
              </Tabs.Content>
              <Tabs.Content class="tabs__content" value="occupancy">
                <Row>
                  <h2>List of Ready to Approve and Sign Occupancy Order of Payments</h2>
                </Row>

                <Padding top={0} bottom={0} right={10} left={0}>
                  <Row content="right">
                    <Button label="Refresh Data" edges="curved" design="bo-primary" icon={VsRefresh} onClick={() => refresh('occupancy')}></Button>
                  </Row>
                </Padding>

                <Row>
                  <table class="table">
                    <thead>
                      <tr>
                        <th>Application Number</th>
                        <th>Name</th>
                        <th style="text-align: center">Show Details</th>
                      </tr>
                    </thead>
                    <tbody>
                      {applicationListOccupancy().map((item, index) => (
                        <tr>
                          <td>{item}</td>
                          <td>{nameListOccupancy()[index]}</td>

                          <td>
                            <ModalButton
                              class="modal"
                              label="Show Details"
                              design="bo-link"
                              background="#121e2acc"
                              color="#ffffffec"
                              function={async () => {
                                await getopdetails('occupancy', item)
                              }}
                            >
                              <Padding top={0} left={2} right={2} bottom={0}>
                                <span class="modal__application-number">{item}</span>

                                <Padding top={1} left={0} right={0} bottom={0}>
                                  <section class="modal__row">
                                    <span class="modal__row__label">Name of Applicant:</span>
                                    <span class="modal__row__detail">{nameListOccupancy()[index]}</span>
                                  </section>

                                  <section class="modal__row">
                                    <span class="modal__row__label">Location:</span>
                                    <span class="modal__row__detail">{location()}</span>
                                  </section>

                                  <section class="modal__row">
                                    <span class="modal__row__label">Type:</span>
                                    <span class="modal__row__detail">{type().toUpperCase()}</span>
                                  </section>

                                  <section class="modal__row">
                                    <span class="modal__row__label">Assessed By:</span>
                                    <span class="modal__row__detail">{assessor()}</span>
                                  </section>

                                  <section class="modal__row">
                                    <span class="modal__row__label">Date Assessed:</span>
                                    <span class="modal__row__detail">{dateOp().toUpperCase()}</span>
                                  </section>

                                  <section class="modal__row">
                                    <span class="modal__row__label">Total Fee:</span>
                                    <span class="modal__row__detail__price">
                                      {PESO} {totalOp().toFixed(2)}
                                    </span>
                                  </section>
                                </Padding>

                                <Row padding="2rem 0 0 0">
                                  <Button wide label="Approve" edges="curved" design="bo-primary" onClick={() => approveHandler(item)}></Button>
                                  <span class="modal__cancel">Click anywhere to cancel</span>
                                </Row>
                              </Padding>
                            </ModalButton>
                          </td>
                        </tr>
                      ))}
                    </tbody>
                  </table>
                </Row>
              </Tabs.Content>
              <Tabs.Content class="tabs__content" value="electrical">
                <Row>
                  <h2>List of Ready to Approve and Sign in Electrical Order of Payments</h2>
                </Row>

                <Padding top={0} bottom={0} right={10} left={0}>
                  <Row content="right">
                    <Button label="Refresh Data" edges="curved" design="bo-primary" icon={VsRefresh} onClick={() => refresh('electrical')}></Button>
                  </Row>
                </Padding>

                <Row>
                  <table class="table">
                    <thead>
                      <tr>
                        <th>Application Number</th>
                        <th>Name</th>
                        <th style="text-align: center">Show Details</th>
                      </tr>
                    </thead>
                    <tbody>
                      {applicationListElectrical().map((item, index) => (
                        <tr>
                          <td>{item}</td>
                          <td>{nameListElectrical()[index]}</td>

                          <td>
                            <ModalButton
                              class="modal"
                              label="Show Details"
                              design="bo-link"
                              background="#121e2acc"
                              color="#ffffffec"
                              function={async () => {
                                await getopdetails('electrical', item)
                              }}
                            >
                              <Padding top={0} left={2} right={2} bottom={0}>
                                <span class="modal__application-number">{item}</span>

                                <Padding top={1} left={0} right={0} bottom={0}>
                                  <section class="modal__row">
                                    <span class="modal__row__label">Name of Applicant:</span>
                                    <span class="modal__row__detail">{nameListElectrical()[index]}</span>
                                  </section>

                                  <section class="modal__row">
                                    <span class="modal__row__label">Location:</span>
                                    <span class="modal__row__detail">{location()}</span>
                                  </section>

                                  <section class="modal__row">
                                    <span class="modal__row__label">Type:</span>
                                    <span class="modal__row__detail">{type().toUpperCase()}</span>
                                  </section>

                                  <section class="modal__row">
                                    <span class="modal__row__label">Assessed By:</span>
                                    <span class="modal__row__detail">{assessor()}</span>
                                  </section>

                                  <section class="modal__row">
                                    <span class="modal__row__label">Date Assessed:</span>
                                    <span class="modal__row__detail">{dateOp().toUpperCase()}</span>
                                  </section>

                                  <section class="modal__row">
                                    <span class="modal__row__label">Total Fee:</span>
                                    <span class="modal__row__detail__price">
                                      {PESO} {totalOp().toFixed(2)}
                                    </span>
                                  </section>
                                </Padding>

                                <Row padding="2rem 0 0 0">
                                  <Button wide label="Approve" edges="curved" design="bo-primary" onClick={() => approveHandler(item)}></Button>
                                  <span class="modal__cancel">Click anywhere to cancel</span>
                                </Row>
                              </Padding>
                            </ModalButton>
                          </td>
                        </tr>
                      ))}
                    </tbody>
                  </table>
                </Row>
              </Tabs.Content>
            </Tabs>
          </Row>
        </Padding>
      </Page>

      <div onClick={() => setApproved(false)}>
        <Modal trigger={approved()} background="#123220ff" color="#cdfbe1f0" opacity={0.8}>
          <Padding top={1} bottom={1} left={2} right={2}>
            <Column>
              <Row gap={4}>
                <FaSolidThumbsUp size={75} />
                <Box curved thickness={3} color="#cdfbe1f0" padding="1rem">
                  <span class="approval">Approved</span>
                </Box>
              </Row>
              <Row padding="2rem 0 0 0">
                <h2>{approvedApplication()}</h2>
              </Row>

              <Row>
                <span class="close-text">Click anywhere to proceed</span>
              </Row>
            </Column>
          </Padding>
        </Modal>
      </div>

      <div onClick={closeNotification}>
        <Modal trigger={approved()} background="#123220ff" color="#cdfbe1f0" opacity={0.8}>
          <Padding top={1} bottom={1} left={2} right={2}>
            <Column>
              <Row gap={4}>
                <FaSolidThumbsUp size={75} />
                <Box curved thickness={3} color="#cdfbe1f0" padding="1rem">
                  <span class="approval">Approved</span>
                </Box>
              </Row>
              <Row padding="2rem 0 0 0">
                <h2>{approvedApplication()}</h2>
              </Row>

              <Row>
                <span class="close-text">Click anywhere to proceed</span>
              </Row>
            </Column>
          </Padding>
        </Modal>
      </div>

      <div onClick={() => setConnected(true)}>
        <Modal trigger={connected() === false} background="#562020ff" color="#ffebebe6" opacity={0.8}>
          <Padding top={1} bottom={1} left={4} right={4}>
            <Column>
              <Row>
                <Box curved thickness={3} color="#ffebebe6" padding="1rem">
                  <h2>Connection Error</h2>
                </Box>
              </Row>

              <Row>
                <h3>{errorMessage()}</h3>
              </Row>

              <Row>
                <span class="close-text">Click anywhere to close</span>
              </Row>
            </Column>
          </Padding>
        </Modal>
      </div>
    </>
  )
}
